---
title: MessageEvent.source
slug: Web/API/MessageEvent/source
tags:
  - API
  - DOM
  - MessageEvent
  - Property
  - Reference
  - messaging
  - source
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <code><strong>source</strong></code> read-only property of the {{domxref("MessageEvent")}} interface is a <code>MessageEventSource</code> (which can be a {{domxref("WindowProxy")}}, {{domxref("MessagePort")}}, or {{domxref("ServiceWorker")}} object) representing the message emitter.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>mySource</em> = <em>messageEvent</em>.source;</pre>

<h3 id="Value">Value</h3>

<p>a <code>MessageEventSource</code> (which can be a {{domxref("WindowProxy")}}, {{domxref("MessagePort")}}, or {{domxref("ServiceWorker")}} object) representing the message emitter.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">myWorker.onmessage = function(e) {
  result.textContent = e.data;
  console.log('Message received from worker');
  console.log(e.source);
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "#dom-messageevent-source", " MessageEvent: source")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MessageEvent.source")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("ExtendableMessageEvent")}} — similar to this interface but used in interfaces that needs to give more flexibility to authors.</li>
</ul>
